package lib.ui.elements;

import lib.ui.rendere.UIEventDelegate;

/**
	Find the responsable UIElement to handle the event based on position. Element can be layerd.
	Elements added first are lower in the layer. 
**/
abstract EventMap(Array<{bound:Rect, delegate:UIEventDelegate}>) {
	inline public function new(?i:Array<{bound:Rect, delegate:UIEventDelegate}>) {
		if (i == null) {
			this = new Array<{bound:Rect, delegate:UIEventDelegate}>();
		} else {
			this = i;
		}
	}

	public function findResponseableDelegate(pos:Pos):UIEventDelegate {
		for (i in 0...this.length) {
			var newi = (this.length - 1) - i;
			var element = this[newi];
			if (element.bound.isInside(pos)) {
				return element.delegate;
			}
		}
		return null;
	}

	public inline function addElement(element:UIEventDelegate, bound:Rect) {
		this.push({bound: bound, delegate: element});
	}
}
